#define RX_STATUS_PIN 2

volatile uint8_t  DmxRxField[1]; //array of DMX vals (raw)
volatile uint16_t DmxAddress;	 //start address

enum {IDLE, BREAK, STARTB, STARTADR}; //DMX states

volatile uint8_t gDmxState;

void setup()
{
  Serial.begin(250000); //Enable serial reception with a 250k rate
  pinMode(RX_STATUS_PIN, OUTPUT); //RX STATUS LED pin, blinks on incoming DMX data
  gDmxState= IDLE; // initial state
  DmxAddress = 1; // The desired DMX Start Adress
  pinMode(13,OUTPUT); //added by me for an example. 
}

ISR(USART0_RX_vect) {
	digitalWrite(RX_STATUS_PIN, HIGH);
	static  uint16_t DmxCount;
	uint8_t  USARTstate= UCSR0A;    //get state before data!
	uint8_t  DmxByte   = UDR0;	    //get data
	uint8_t  DmxState  = gDmxState;	//just load once from SRAM to increase speed

	if (USARTstate &(1<<FE0))		//check for break
	{
		DmxCount =  DmxAddress;		//reset channel counter (count channels before start address)
		gDmxState= BREAK;
	}

	else if (DmxState == BREAK)
	{
		if (DmxByte == 0) gDmxState= STARTB;  //normal start code detected
		else			  gDmxState= IDLE;
	}

	else if (DmxState == STARTB)
	{
		if (--DmxCount == 0)	//start address reached?
		{
			DmxCount= 1;		//set up counter for required channels
			DmxRxField[0]= DmxByte;	//get 1st DMX channel of device
			gDmxState= STARTADR;
		}
	}

	else if (DmxState == STARTADR)
	{
		DmxRxField[DmxCount++]= DmxByte;	//get channel
		if (DmxCount >= sizeof(DmxRxField)) //all ch received?
		{
			gDmxState= IDLE;	//wait for next break
		}
	}
	digitalWrite(RX_STATUS_PIN, LOW);							
}

void loop()
{
  if(DmxRxField[0]>127)
  {
    digitalWrite(13, HIGH);
  }
  else 
  {
    digitalWrite(13, LOW);
  }
}

